@import url(fonts/clear-sans.css);

html,
body {
  margin: 0;
  padding: 0;
  background: #faf8ef;
  color: #776e65;
  font-family: "Clear Sans", "Helvetica Neue", Arial, sans-serif;
  font-size: 18px;
}

body {
  margin: 0;
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 100vh;
  overflow: hidden;
}

.container {
  width: 500px;
  margin: 0 auto;
  display: flex;
  flex-direction: column;
  align-items: center;
}

h1.title {
  font-size: 100px;
  font-weight: 900;
  margin-bottom: 8vh;
  text-align: center;
  letter-spacing: 5px;
}

.scores-container {
  display: flex;
  justify-content: center;
  gap: 5px;
  margin-bottom: 20px;
}

.score-container,
.best-container {
  position: relative;
  background: #bbada0;
  padding: 15px 25px;
  font-size: 25px;
  height: 25px;
  line-height: 47px;
  font-weight: bold;
  border-radius: 3px;
  color: white;
  text-align: center;
  min-width: 60px;
}

.score-container:after,
.best-container:after {
  position: absolute;
  width: 100%;
  top: 10px;
  left: 0;
  text-transform: uppercase;
  font-size: 13px;
  line-height: 13px;
  text-align: center;
  color: #eee4da;
}

.score-container:after {
  content: "Счет";
}
.best-container:after {
  content: "Лучший";
}

.game-container {
  position: relative;
  padding: 15px;
  cursor: default;
  background: #bbada0;
  border-radius: 6px;
  width: 500px;
  height: 500px;
  box-sizing: border-box;
  touch-action: none;
}

.restart-button {
  display: flex;
  align-items: center;
  justify-content: center;
  text-align: center;
  background: #bbada0;
  border-radius: 8px;
  padding: 10px 32px;
  text-decoration: none;
  color: #f9f6f2;
  height: auto;
  min-height: 42px;
  line-height: 1.2;
  font-size: 24px;
  font-weight: bold;
  margin-top: 70px;
  margin-bottom: 20vh;
  cursor: pointer;
  border: none;
}

.game-message {
  display: none;
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  background: rgba(238, 228, 218, 0.5);
  z-index: 100;
  text-align: center;
  animation: fade-in 800ms ease 1200ms both;
}

.game-message p {
  font-size: 60px;
  font-weight: bold;
  margin-top: 222px;
}

.grid-container {
  position: absolute;
  z-index: 1;
}

.grid-row {
  margin-bottom: 15px;
  display: flex;
}

.grid-row:last-child {
  margin-bottom: 0;
}

.grid-cell {
  width: 106.25px;
  height: 106.25px;
  margin-right: 15px;
  border-radius: 3px;
  background: rgba(238, 228, 218, 0.35);
}

.grid-cell:last-child {
  margin-right: 0;
}

.tile-container {
  position: absolute;
  z-index: 2;
}

.tile,
.tile .tile-inner {
  width: 107px;
  height: 107px;
  line-height: 107px;
}

.tile {
  position: absolute;
  transition: 100ms ease-in-out;
  transition-property: transform;
}

.tile .tile-inner {
  border-radius: 3px;
  background: #eee4da;
  text-align: center;
  font-weight: bold;
  font-size: 55px;
}

.tile.tile-2 .tile-inner {
  background: #eee4da;
}
.tile.tile-4 .tile-inner {
  background: #ede0c8;
}
.tile.tile-8 .tile-inner {
  color: #f9f6f2;
  background: #f2b179;
}
.tile.tile-16 .tile-inner {
  color: #f9f6f2;
  background: #f59563;
}
.tile.tile-32 .tile-inner {
  color: #f9f6f2;
  background: #f67c5f;
}
.tile.tile-64 .tile-inner {
  color: #f9f6f2;
  background: #f65e3b;
}
.tile.tile-128 .tile-inner {
  color: #f9f6f2;
  background: #edcf72;
  font-size: 45px;
}
.tile.tile-256 .tile-inner {
  color: #f9f6f2;
  background: #edcc61;
  font-size: 45px;
}
.tile.tile-512 .tile-inner {
  color: #f9f6f2;
  background: #edc850;
  font-size: 45px;
}
.tile.tile-1024 .tile-inner {
  color: #f9f6f2;
  background: #edc53f;
  font-size: 35px;
}
.tile.tile-2048 .tile-inner {
  color: #f9f6f2;
  background: #edc22e;
  font-size: 35px;
}

.tile.tile-position-1-1 {
  transform: translate(0px, 0px);
}
.tile.tile-position-1-2 {
  transform: translate(0px, 121px);
}
.tile.tile-position-1-3 {
  transform: translate(0px, 242px);
}
.tile.tile-position-1-4 {
  transform: translate(0px, 363px);
}
.tile.tile-position-2-1 {
  transform: translate(121px, 0px);
}
.tile.tile-position-2-2 {
  transform: translate(121px, 121px);
}
.tile.tile-position-2-3 {
  transform: translate(121px, 242px);
}
.tile.tile-position-2-4 {
  transform: translate(121px, 363px);
}
.tile.tile-position-3-1 {
  transform: translate(242px, 0px);
}
.tile.tile-position-3-2 {
  transform: translate(242px, 121px);
}
.tile.tile-position-3-3 {
  transform: translate(242px, 242px);
}
.tile.tile-position-3-4 {
  transform: translate(242px, 363px);
}
.tile.tile-position-4-1 {
  transform: translate(363px, 0px);
}
.tile.tile-position-4-2 {
  transform: translate(363px, 121px);
}
.tile.tile-position-4-3 {
  transform: translate(363px, 242px);
}
.tile.tile-position-4-4 {
  transform: translate(363px, 363px);
}

@keyframes fade-in {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

@keyframes appear {
  0% {
    opacity: 0;
    transform: scale(0);
  }
  100% {
    opacity: 1;
    transform: scale(1);
  }
}

.tile-new .tile-inner {
  animation: appear 200ms ease 100ms backwards;
}

@media screen and (max-width: 520px) {
  .container {
    width: 280px;
  }
  .game-container {
    width: 280px;
    height: 280px;
    padding: 10px;
  }
  .grid-cell {
    width: 57.5px;
    height: 57.5px;
    margin-right: 10px;
  }
  .grid-row {
    margin-bottom: 10px;
  }
  .tile,
  .tile .tile-inner {
    width: 58px;
    height: 58px;
    line-height: 58px;
    font-size: 25px;
  }
    .tile.tile-128 .tile-inner,
    .tile.tile-256 .tile-inner,
    .tile.tile-512 .tile-inner {
      font-size: 20px;
    }
  
    .tile.tile-1024 .tile-inner,
    .tile.tile-2048 .tile-inner {
      font-size: 15px;
    }
  h1.title {
    font-size: 40px;
  }

  .tile.tile-position-1-1 {
    transform: translate(0px, 0px);
  }
  .tile.tile-position-1-2 {
    transform: translate(0px, 67.5px);
  }
  .tile.tile-position-1-3 {
    transform: translate(0px, 135px);
  }
  .tile.tile-position-1-4 {
    transform: translate(0px, 202.5px);
  }
  .tile.tile-position-2-1 {
    transform: translate(67.5px, 0px);
  }
  .tile.tile-position-2-2 {
    transform: translate(67.5px, 67.5px);
  }
  .tile.tile-position-2-3 {
    transform: translate(67.5px, 135px);
  }
  .tile.tile-position-2-4 {
    transform: translate(67.5px, 202.5px);
  }
  .tile.tile-position-3-1 {
    transform: translate(135px, 0px);
  }
  .tile.tile-position-3-2 {
    transform: translate(135px, 67.5px);
  }
  .tile.tile-position-3-3 {
    transform: translate(135px, 135px);
  }
  .tile.tile-position-3-4 {
    transform: translate(135px, 202.5px);
  }
  .tile.tile-position-4-1 {
    transform: translate(202.5px, 0px);
  }
  .tile.tile-position-4-2 {
    transform: translate(202.5px, 67.5px);
  }
  .tile.tile-position-4-3 {
    transform: translate(202.5px, 135px);
  }
  .tile.tile-position-4-4 {
    transform: translate(202.5px, 202.5px);
  }
}
